% contents.m
% 
% This directory contains a example files that illustrates
% some of the algorithm developed in the toolsvm or toolreg
% 
% File                              |         Comments
%
%
% ------------------------- Classification----------------------
%
% exclass                           | 2D SVM Classification problem 
%                                   |
% exclass1                          | 2D SVM Classification problem with different C
%                                   | penalization and wavelet kernels
% exclass2                          | Comparing Gaussian Kernel and Polynomial Kernel on 2D
%                                   | SVM Classification problem
% exclass3                          | 2D SVM Classification with Semiparametric models
%                                   |
% exclassalphainit                  | Example of initialization of the Lagragian
%                                   | Multipliers in the QP Solver
% exclasscheckershaarkernel         | Comparing Haar Kernel and Gaussian Kernel on
%                                   | the checker problem
% exclasscheckershaarkernel2        | Comparing Haar Kernel and Gaussian Kernel on
%                                   | the checker problem based on 100 trials
% exclassls                         | Example of large-scale classification problem
%                                   |
% exclassnpa                        | Example of SVM Classification Using NPA algorithm
%                                   |
% exclassrn                         | Regularization Networks for classifying the CheckerBoard
%                                   | Problem
% exclassrn1                        | SemiParametric Regularization Networks 
%                                   | Problem
% exmulticlass                      | Example of multiclass problem using
%                                   | "one-against-all" algorithm
% exmulticlass1                     | Treating the example presented by Lin & Wahba and analysing
%                                   | "One against all" and "one-against-one" algorithm
% exmulticlass2                     | Treating another example with "one-against-one" algorithm
%                                   | and comparing the pdf of each class and decision bondaries
% exmulticlass1v1                   | Example of multiclass problem using
%                                   | "one-against-one" algorithm
% exmulticlassall                   | M-SVM algorithm for treating the multiclasse problem
%                                   |
% exmulticlassall2                  | Another M-SVM examples with assymetric penalization coefficients
%
% ------------------------- Regression---------------------------
% exreg1d                           | 1D SVM Regression problem    
%                                   |
% exreg2d                           | 2D SVM Regression problem 
%
% exreg1dls                         | 1D Large Scale SVM Regression problem
% ------------------------- Wavelet Kernels ---------------------
% extensorwavkernel                 | Example of the different possibility of wavelet kernel
%                                   | On a classification problems
%                                   | (You need the WAVELAB TOOLBOX)
%
%-------------------------- Feature Selection -------------------
% FeatSelAdaptScal                  | Demo of the SVM adaptive scaling method of GrandValet & Canu
%                                   | 
% FeatSelAdaptScal1                 | Example of adaptive scaling as described in the NIPS paper  
%                                   | See Grandvalet & Canu 2003
%
% FeatSelExample                    | Demo of Rakotomamonjy et al. paper
%---------------------------Kernel PCA -------------------------
% kpca1                             | Simple Example of Kernel PCA on a artificial datasets
%                                   |    
% kpca2                             | Example of KPCA. this is a B.Scholkopf modified routine  
%                                   |
% kpca3                             | Example of Multilayer SVM with a KPCA as a first stage



